#!/usr/bin/python
# -*- coding: utf-8 -*-

import sqlite3 as lite
import sys


def readAudio():

    try:
        fin = open("../Biblioteca/AUDIO/AudioPalabras/bus.mp3", "rb")
        img = fin.read()
        fin.close()
        return img
    except IOError, e:
        print "Error %d: %s" % (e.args[0],e.args[1])
        sys.exit(1)


try:
    con = lite.connect('BaseDatosAplicacion.db')

    cur = con.cursor()
    data = readAudio()
    binary = lite.Binary(data)
    cur.execute("UPDATE diccionario SET dic_sonido=? WHERE dic_id=?", (binary, 6))

    con.commit()

except lite.Error, e:

    if con:
        con.rollback()

    print "Error %s:" % e.args[0]
    sys.exit(1)

finally:

    if con:
        con.close()