import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from dificultad import Ui_From_FonologicaMenu



class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()
    Elegido = QtCore.pyqtSignal()

class VentanaDificultad(QtGui.QWidget):

    def __init__(self, Datos,DatosPac):
        super(VentanaDificultad, self).__init__()
        self.datos = Datos
        self.datosPac = DatosPac
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.dificultad = 1
        self.ui = Ui_From_FonologicaMenu()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.InfoPac()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))


    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_dificultadE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Normal.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_Avanzado.setStyleSheet("background-color: rgb(102, 179, 255)")


    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_Normal.clicked.connect(self.AbrirVentanaEjercicio)
        self.ui.btn_Avanzado.clicked.connect(self.AbrirVentanaEjercicio)



    def AbrirVentanaEjercicio(self):
        sender = self.sender()
        if sender.text() == 'Normal':
            self.dificultad = 1
        elif sender.text() == 'Avanzado':
            self.dificultad = 2
        self.c.Elegido.emit()

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

    def clickSalir(self, event):
        self.c.Back.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaDificultad()
    myapp.show()
    sys.exit(app.exec_())
