# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from ingresoTexto import Ui_frm_ingresoTeclado

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)



class Communicate(QtCore.QObject):
    closeApp = QtCore.pyqtSignal()

class VentanaIngresoTexto(QtGui.QWidget):

    def __init__(self, textoActual):
        super(VentanaIngresoTexto, self).__init__()
        self.textoActual = textoActual
        self.ui = Ui_frm_ingresoTeclado()
        self.ui.setupUi(self)
        self.modificarBotones()
        self.conexiones()
        self.texto = self.textoActual
        self.ui.txt_escrito.setPlainText(self.textoActual)
        self.c = Communicate()
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)
        #self.cursor = self.ui.txt_escrito.textCursor()

    def modificarBotones(self):
        for i in range(1, 50, 1):
            self.boton = eval('self.ui.btn_' + str(i))
            self.boton.setStyleSheet("QPushButton { background-color: rgb(153, 255, 102) }"
                                     "QPushButton:pressed { background-color: rgb(102, 153, 255) }")

    def conexiones(self):
        for j in range(1, 51, 1):
            self.comando = 'self.ui.btn_' + str(j) + '.clicked.connect(self.pulsoTecla)'
            eval(self.comando)
            self.ui.btn_51.clicked.connect(self.pulsoEnter)

    def pulsoTecla(self):
        sender = self.sender()
        self.cursor = self.ui.txt_escrito.textCursor()
        if sender.text() == "BKM":
            self.pulsoBKM()
        elif sender.text() == "SFT":
            self.pulsoSFT()
        elif sender.text() == "BORRAR":
            self.cursor.deletePreviousChar()
        elif sender.text() == "ESPACIO":
            self.cursor.insertText(" ")
        else:
            self.cursor.insertText(sender.text())
        self.texto = self.ui.txt_escrito.toPlainText()


    def pulsoBKM(self):
        if self.ui.btn_13.text() == 'q':
            self.ui.btn_13.setText("Q")
            self.ui.btn_14.setText("W")
            self.ui.btn_15.setText("E")
            self.ui.btn_16.setText("R")
            self.ui.btn_17.setText("T")
            self.ui.btn_18.setText("Y")
            self.ui.btn_19.setText("U")
            self.ui.btn_20.setText("I")
            self.ui.btn_21.setText("O")
            self.ui.btn_22.setText("P")
            self.ui.btn_25.setText("A")
            self.ui.btn_26.setText("S")
            self.ui.btn_27.setText("D")
            self.ui.btn_28.setText("F")
            self.ui.btn_29.setText("G")
            self.ui.btn_30.setText("H")
            self.ui.btn_31.setText("J")
            self.ui.btn_32.setText("K")
            self.ui.btn_33.setText("L")
            self.ui.btn_34.setText(_translate("frm_ingresoTeclado", "Ñ", None))
            self.ui.btn_38.setText("Z")
            self.ui.btn_39.setText("X")
            self.ui.btn_40.setText("C")
            self.ui.btn_41.setText("V")
            self.ui.btn_42.setText("B")
            self.ui.btn_43.setText("N")
            self.ui.btn_44.setText("M")
        else:
            self.ui.btn_13.setText("q")
            self.ui.btn_14.setText("w")
            self.ui.btn_15.setText("e")
            self.ui.btn_16.setText("r")
            self.ui.btn_17.setText("t")
            self.ui.btn_18.setText("y")
            self.ui.btn_19.setText("u")
            self.ui.btn_20.setText("i")
            self.ui.btn_21.setText("o")
            self.ui.btn_22.setText("p")
            self.ui.btn_25.setText("a")
            self.ui.btn_26.setText("s")
            self.ui.btn_27.setText("d")
            self.ui.btn_28.setText("f")
            self.ui.btn_29.setText("g")
            self.ui.btn_30.setText("h")
            self.ui.btn_31.setText("j")
            self.ui.btn_32.setText("k")
            self.ui.btn_33.setText("l")
            self.ui.btn_34.setText(_translate("frm_ingresoTeclado", "ñ", None))
            self.ui.btn_38.setText("z")
            self.ui.btn_39.setText("x")
            self.ui.btn_40.setText("c")
            self.ui.btn_41.setText("v")
            self.ui.btn_42.setText("b")
            self.ui.btn_43.setText("n")
            self.ui.btn_44.setText("m")

    def pulsoSFT(self):
        if self.ui.btn_1.text() == '1':
            self.ui.btn_1.setText("!")
            self.ui.btn_2.setText("@")
            self.ui.btn_3.setText("#")
            self.ui.btn_4.setText("$")
            self.ui.btn_5.setText("%")
            self.ui.btn_6.setText("^")
            self.ui.btn_7.setText("&&")
            self.ui.btn_8.setText("*")
            self.ui.btn_9.setText("(")
            self.ui.btn_10.setText(")")
            self.ui.btn_11.setText("_")
            self.ui.btn_12.setText("+")
            self.ui.btn_23.setText("{")
            self.ui.btn_24.setText("}")
            self.ui.btn_35.setText(":")
            self.ui.btn_36.setText("''")
            self.ui.btn_45.setText("<")
            self.ui.btn_46.setText(">")
            self.ui.btn_47.setText("?")

        else:
            self.ui.btn_1.setText("1")
            self.ui.btn_2.setText("2")
            self.ui.btn_3.setText("3")
            self.ui.btn_4.setText("4")
            self.ui.btn_5.setText("5")
            self.ui.btn_6.setText("6")
            self.ui.btn_7.setText("7")
            self.ui.btn_8.setText("8")
            self.ui.btn_9.setText("9")
            self.ui.btn_10.setText("0")
            self.ui.btn_11.setText("-")
            self.ui.btn_12.setText("=")
            self.ui.btn_23.setText("[")
            self.ui.btn_24.setText("]")
            self.ui.btn_35.setText(";")
            self.ui.btn_36.setText("'")
            self.ui.btn_45.setText(",")
            self.ui.btn_46.setText(".")
            self.ui.btn_47.setText("/")

    def pulsoEnter(self, event):
        self.c.closeApp.emit()

    def getTexto(self):
        return self.ui.txt_escrito.toPlainText()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaIngresoTexto()
    myapp.show()
    sys.exit(app.exec_())


