# -*- coding: utf-8 -*-
import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from AplicacionCodigo.Ventanas.VentanaIngresoTexto import VentanaIngresoTexto
from AplicacionCodigo.Ventanas.VentanaNumeros import VentanaNumeros


try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaMetodosIngreso():

    def __init__(self):
        pass

    def getTexto(self, QObject, textoActual):
        self.objeto = QObject
        self.teclado = VentanaIngresoTexto(textoActual)
        QtGui.QWidget.setWindowFlags(self.teclado, QtCore.Qt.FramelessWindowHint)
        self.teclado.show()
        self.teclado.c.closeApp.connect(self.cerrarTeclado)

    def cerrarTeclado(self):
        textoIngresado = self.teclado.getTexto()
        if isinstance(self.objeto, QtGui.QPlainTextEdit):
            self.objeto.setPlainText(textoIngresado)
        else:
            self.objeto.setText(textoIngresado)
        self.teclado.close()


    def getNumero(self, numeros, maximo, QObject):
        self.objeto = QObject
        self.maximo = maximo
        self.numeros = VentanaNumeros(numeros)
        QtGui.QWidget.setWindowFlags(self.numeros, QtCore.Qt.FramelessWindowHint)
        self.numeros.show()
        self.numeros.c.closeApp.connect(self.cerrarNumeros)

    def cerrarNumeros(self):
        numeroIngresado = self.numeros.getInput()
        if int(numeroIngresado) > self.maximo:
            numeroIngresado = ""
            QMessageBox.about(self.numeros, 'Alerta', _translate('getNumeros','El número maximo a ingresar en este campo es:\n' + str(self.maximo), None))
        self.objeto.setText(numeroIngresado)
        self.numeros.close()




