# -*- coding: utf-8 -*-

import sys
reload(sys)
sys.setdefaultencoding("utf-8")
import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from probarStt import Ui_frm_pruebaStt
import speech_recognition as sr
import urllib
import re
from bs4 import BeautifulSoup




try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaPruebaStt(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaPruebaStt, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_pruebaStt()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.conexiones()
        self.c = Communicate()


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))



    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuSuperUE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def conexiones(self):
        self.ui.btn_iniciarStt.clicked.connect(self.clickIniciar)
        self.ui.btn_buscar.clicked.connect(self.clickBusca)
        self.ui.btnl_Salir.mousePressEvent = self.clickAtras


    def clickIniciar(self,QObject):
        self.borrarTexto()
        R=sr.Recognizer()
        with sr.Microphone() as source:
             print 'di algo'
             audio =R.listen(source)
        try:
            self.Resp=R.recognize_google(audio, key="AIzaSyCCdRD5mlqDBInH2q_CtXjLn-F2iA-yskA",language="es-EC")
            self.normalOutputWritten(self.Resp + '\n' )
            print self.Resp
        except sr.WaitTimeoutError:
            self.normalOutputWritten(' ********** Se agoto el tiempo ************')
            print 'se agoto el tiempo'
        except sr.UnknownValueError:
            self.normalOutputWritten('***********No te entiendo :(*************')
            print 'no te entiendo'
        except sr.RequestError as e:
            self.normalOutputWritten("No se pudo conectar con el servicio ".format(e))
            print 'no se conecto'
        except sr.URLError as e:
            self.normalOutputWritten("No se pudo conectar con el URL  ".format(e))
            print 'no se conecto'



    def clickBuscar(self,text):
        try:
            url = "https://es.wikipedia.org/wiki/"+str(text.replace(" ","_").lower())
            html = urllib.urlopen(url).read()
            soup = BeautifulSoup(html)
            result = soup.p.get_text()
            Imprimir= re.sub("\[.*?\]","",result)
            self.normalOutputWritten( Imprimir )
        except IOError:
            print 'No hay conexion a internet'


    def clickBusca(self):
        self.clickBuscar(self.Resp)

    def borrarTexto(self):
        self.ui.txt_mostrarStt.clear()

    def normalOutputWritten(self, text):
        cursor = self.ui.txt_mostrarStt.textCursor()
        cursor.movePosition(QtGui.QTextCursor.End)
        cursor.insertText(text)
        self.ui.txt_mostrarStt.setTextCursor(cursor)
        self.ui.txt_mostrarStt.ensureCursorVisible()


    def clickAtras(self, event):
        self.c.Back.emit()

    def clickSalir(self):
        self.c.Back.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaPruebaStt()
    myapp.show()
    sys.exit(app.exec_())

