import sys
from PyQt4 import QtGui

#sys.path.append('../Ventanas')

from VentanaLogin import *
from VentanaMPAdmin import *
from VentanaMPTerap import *
from VentanaMPSuperU import *

#import subprocess

class ManejoVentanas():

    def __init__(self):
        self.datos = None
        self.app = QtGui.QApplication(sys.argv)
        self.log = VentanaLogin()
        self.log.show()
        self.log.c.closeApp.connect(self.abrirMenu)

    def abrirLogin(self):
        self.datos = None
        self.log = VentanaLogin()
        self.log.show()
        self.menu.close()
        self.menu = None
        self.log.c.closeApp.connect(self.abrirMenu)

    def abrirMenu(self):
        self.datos = self.log.DatosLog
        if self.datos[2] == "Administrador":
            self.abrirMenuAdmin()
        elif self.datos[2] == "Terapista":
            self.abrirMenuTerap()
        elif self.datos[2] == "SuperUsuario":
            self.abrirMenuSuperU()
        self.log.close()
        self.log = None


    def abrirMenuAdmin(self):
        self.menu = VentanaMPAdmin(self.datos)
        self.menu.show()
        self.menu.c.closeApp.connect(self.abrirLogin)

    def abrirMenuTerap(self):
        self.menu = VentanaMPTerap(self.datos)
        self.menu.show()
        self.menu.c.closeApp.connect(self.abrirLogin)

    def abrirMenuSuperU(self):
        self.menu = VentanaMPSuperU(self.datos)
        self.menu.show()
        self.menu.c.closeApp.connect(self.abrirLogin)


if __name__ == '__main__':
    af = ManejoVentanas()
    sys.exit(af.app.exec_())
    pr.c.closeApp.connect(self.abrirMenu)


