#from AplicacionCodigo.Servidor.CamaraUbuntu import *
from AplicacionCodigo.Servidor.CamaraRaspberry import *
import time



class VentanaDeteccionFacial:

    def __init__(self):
        self.paro = False

    def abrirVentanaCamara(self, ventana):
        #c = Camara(0)
        c = Camara()
        time.sleep(0.1)
        d = DeteccionFacial(cascade_fn="Servidor/haarcascade_frontalface_alt2.xml")
        cv2.namedWindow('ReconocimientoFacial', cv2.WINDOW_AUTOSIZE)
        cv2.setMouseCallback('ReconocimientoFacial', self.verclick, None)
        cv2.moveWindow('ReconocimientoFacial', 0, 0)
        ventana.hide()
        while True:
            captura = c.capturarImagen()
            self.captura = captura
            img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
            caras = d.detectar(img)
            d.numeroCaras(img)
            salida = d.delimitar(img, caras)
            img1 = cv2.resize(salida, (salida.shape[1] * 5, salida.shape[0] * 4), interpolation=cv2.INTER_CUBIC)
            cv2.imshow('ReconocimientoFacial', img1)
            if self.paro == True:
                break
            ch = cv2.waitKey(10)
            if ch == 27:
                break
        cv2.destroyAllWindows()
        c = None

    def verclick(self, event, x, y, flags, serdata):
        if event == cv2.EVENT_LBUTTONDOWN:
            cv2.imwrite('../AplicacionCodigo/Estatico/UltimaFoto.jpg', self.captura)
            self.paro = True


if __name__ == "__main__":
    myapp = VentanaDeteccionFacial()
    myapp.abrirVentanaCamara()


