import sys
import time
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from motores import Ui_frm_motores
from AplicacionCodigo.Servidor.motores3 import *


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaMotores(QtGui.QWidget, QtCore.QObject):

    def __init__(self, Datos):
        super(VentanaMotores, self).__init__()
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_motores()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.m = Motores()

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuSuperUE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_mBDerecho.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_mBIzquierdo.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_mCabeza.setStyleSheet("background-color: rgb(255, 179, 102)")
        self.ui.btn_mRDerecha.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_mRIzquierda.setStyleSheet("background-color: rgb(102, 179, 255)")

    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        self.ui.btn_mCabeza.clicked.connect(self.moverCabeza)
        self.ui.btn_mBDerecho.clicked.connect(self.moverBrazoDerecho)
        self.ui.btn_mBIzquierdo.clicked.connect(self.moverBrazoIzquierdo)
        self.ui.btn_mRDerecha.clicked.connect(self.moverRuedaDerecha)
        self.ui.btn_mRIzquierda.clicked.connect(self.moverRuedaIzquierda)

    def moverCabeza(self):
        self.m.moverCabeza(0)
        time.sleep(1)
        self.m.moverCabeza(270)
        time.sleep(1)
        self.m.moverCabeza(135)

    def moverBrazoIzquierdo(self):
        self.m.moverBrazoIzquierdo(0)
        time.sleep(1)
        self.m.moverBrazoIzquierdo(270)
        time.sleep(1)
        self.m.moverBrazoIzquierdo(135)

    def moverBrazoDerecho(self):
        self.m.moverBrazoDerecho(0)
        time.sleep(1)
        self.m.moverBrazoDerecho(270)
        time.sleep(1)
        self.m.moverBrazoDerecho(135)

    def moverRuedaIzquierda(self):
        self.m.moverRuedaIzquierda()

    def moverRuedaDerecha(self):
        self.m.moverRuedaDerecha()


    def clickAtras(self, event):
        self.c.Back.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaMotores()
    myapp.show()
    sys.exit(app.exec_())


