import sys
import time
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from numeros import Ui_frm_numeros


class Communicate(QtCore.QObject):
    closeApp = QtCore.pyqtSignal()

class VentanaNumeros(QtGui.QWidget):

    def __init__(self, cantidad):
        self.numerosR = cantidad
        super(VentanaNumeros, self).__init__()
        self.c = Communicate()
        self.ui = Ui_frm_numeros()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.l = False
        self.input = ''
        self.contadorNumeros = 0


    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_loginE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        for i in range(1, 11, 1):
            self.boton = eval('self.ui.btn_' + str(i))
            self.region = QtGui.QRegion(QtCore.QRect(2.5, 2.5, 75, 75), QtGui.QRegion.Ellipse)
            self.boton.setMask(self.region)
            self.boton.setStyleSheet("QPushButton { background-color: rgb(153, 255, 102) }"
                                     "QPushButton:pressed { background-color: rgb(102, 153, 255) }")

    def conexiones(self):
        for j in range(1, 11, 1):
            self.comando = 'self.ui.btn_' + str(j) + '.clicked.connect(self.digitoNumero)'
            eval(self.comando)


    def digitoNumero(self):
        sender = self.sender()
        if self.contadorNumeros < self.numerosR:
            self.input = self.input + (sender.text())
            self.ui.txt_input.setPlainText(self.input)
            self.contadorNumeros += 1
        if self.contadorNumeros == self.numerosR:
            self.c.closeApp.emit()

    def getInput(self):
        return self.input



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    login = VentanaNumeros()
    login.show()
    sys.exit(app.exec_())


