# -*- coding: utf-8 -*-

import sys
reload(sys)
sys.setdefaultencoding("utf-8")
import sys
from PyQt4 import QtCore, QtGui

from PyQt4.QtGui import *

from AplicacionCodigo.Servidor.tts import  TTS
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso
from probarTts  import Ui_frm_pruebaTts

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaProbarTts(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaProbarTts, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_pruebaTts()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.mI = VentanaMetodosIngreso()



    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))


    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuSuperUE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Inicar.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.txt_texto.installEventFilter(self)
        self.ui.btn_Inicar.setFocus(True)



    def conexiones(self):
        self.ui.btn_Inicar.clicked.connect(self.clickIniciar)
        self.ui.btnl_Salir.mousePressEvent = self.clickAtras


    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
                self.ui.btnl_Salir.setFocus(True)
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)


    def clickIniciar(self):
        Texto = self.ui.txt_texto.toPlainText()
        print (Texto)
        leer = TTS()
        leer.hablar(Texto)


    def clickAtras(self, event):
        self.c.Back.emit()

    def clickSalir(self):

        self.c.Back.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaPruebaTts()
    myapp.show()
    sys.exit(app.exec_())

